<?php
    echo "\n";
    
    // ==========================================
    //                Navigation
    // ==========================================

    $plugin_folder = path($file, "dirname");
    $json_path = "$plugin_folder/categories_map.json";
    $pathes = [ "pages" ];

    function loadCategories($pathes, $root) {
        $files_data = [];
        $files_done = [];
        foreach($pathes as $path) {
            foreach(filesTree("$root/$path", "json,draft") as $file) {
                if(path($file, "extension") == "draft") { $file = substr($file, 0, (strlen($file) - 6)); }
                if(!in_array($file, $files_done)) {
                    
                    $xml = loadXml($file, "draft");
                    $data = false;
                    if(isset($xml["categories"][0]["_categories_list"])) {
                        // Master
                        foreach(readXml($xml, "categories _categories_list") as $category) {
                            list($key, $title) = explode(";", $category);
                            $files_data[$file]["titles"]["key_".$key] = $title;
                        }
                    }
                    elseif(isset($xml["header"][0]["_category"])) {
                        // Subpage
                        $master_path = $xml["header"][0]["_category"][0]["description"][0];
                        $master_path = trim(array_pop(explode(":", $xml["header"][0]["_category"][0]["description"][0])));
                        $master_path = "$root/$master_path";
                        $sub_category = readXml($xml, "header _category");
                        $files_data[$master_path]["items"][$file] = $sub_category;
                        foreach(explode(";", $sub_category) as $key) {
                            if(!isset($files_data[$master_path]["groups"][$key])) { $files_data[$master_path]["groups"][$key] = []; };
                            $files_data[$master_path]["groups"][$key][] = $file;
                        }
                    }
                }
                $files_done[] = $file;
            };
        }
        if(count($files_data) > 0) {
            return arrayToJson($files_data);
        }
        else {
            return false;
        }
    };

    if(!file_exists($json_path) || (isset($_SESSION["published_flag"]) && $_SESSION["published_flag"] == true)) {
        $json = loadCategories($pathes, $root);
        if(safeSave($json_path, $json)) {
            echo "<!-- Categories data saved: '$json_path' -->\n";
        }
    }
    else {
        $json = file_get_contents($json_path);
        echo "<!-- Categories loaded: '$json_path' -->\n";
    };

    if($json) {
        $json_mini = preg_replace('!\s+!', ' ', $json);
        echo "<script>\nvar CATEGORIES_MAP = ".$json_mini."\n</script>\n";
    };

    // ==========================================
    //                  Editor
    // ==========================================
    foreach(array_keys($xml) as $article_name) {
        // ====== Find category section ======
        if(is_array($xml[$article_name][0]["_category"])) {
            $cat_file = $xml[$article_name][0]["_category"][0]["description"][0];
            $cat_file = trim(array_pop(explode(":", $cat_file)));
            // ====== Find categories definitions =======
            $cat_xml = loadXml($root."/".$cat_file);
            foreach(array_keys($cat_xml) as $section_name) {
                if(is_array($cat_xml[$section_name][0]["_categories_list"])) {

                    $cat_multi = ($cat_xml[$section_name][0]["_categories_multi"][0]["selected"][0] != "");
                    $cat_list = $cat_xml[$section_name][0]["_categories_list"][0]["table"][0][$_SESSION['edit_lang']];
                    
                    $cat_labels = $cat_xml[$section_name][0]["_categories_list"][0]["table"][0];
                }
            };
            echo "<script>\n";
            // Categories list
            echo "\tvar CATEGORIES_LIST = {\n";
            foreach($cat_list as $cat_row) {
                list($cat_id, $cat_name) = explode(";", $cat_row);
                echo "\t\t\"key_".$cat_id."\": \"".$cat_name."\",\n";
            }
            echo "\t};\n";
            // Multi options
            if($cat_multi) {
                echo "\tvar CATEGORIES_MULTI = true;\n";
            }
            else {
                echo "\tvar CATEGORIES_MULTI = false;\n";
            };
            echo "</script>\n";    
            // Labels list
            echo "<div id='categories_labels' style='display:none;'>\n".
                arrayToXml($cat_labels, 1).
                "</div>\n";
        }
    }

?>