<?php

    session_start();
    $admin_root = "..";
    $site_root = "../..";

    // ====== Load Functions Libraries ======

    require "$admin_root/repository/functions.php";
    require "$admin_root/repository/cms.php";
    require "$admin_root/repository/xml.php";
    $login = "$admin_root/login.php";
    require "$admin_root/modules/_security.php";

?>

<!doctype html>
<html lang='<?php echo $_SESSION["admin_lang"]; ?>'>
	<head>
		<meta charset="UTF-8">
		<title>X.able CMS / Xable-Jable Updater &amp; Cleaner</title>
		<link href='http://fonts.googleapis.com/css?family=Lato:100,300,400,700,900|Inconsolata:400,700|Audiowide&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
        <link rel="stylesheet" type="text/css" href="<?php echo "$admin_root/_tools/_tools.css?v=0000" ?>" />
        <style>
            #outputs {
                position: relative;
                padding-bottom: 15px;
                overflow: hidden;
            }
            textarea {
                display: block;
                float: left;
                margin: 0;
                padding: 0;
                width: 50%;
                height: 300px;
                resize: none;
            }
            input.text {
                min-width: 50%;
            }
        </style>
    </head>
    <body>
        <button class='close' onclick="self.close()">X</button>
        
<?php
    
    // ====================================
    //              Functions
    // ====================================

    function jableCleaner($root) {
        $path = "$root/tmp/xable-jable";
        if(file_exists($path) && is_dir($path)) {
            removeDir($path);
            echo "[Remove directory:] \"$path\"<hr>\n";
        }

        $deleted = [];
        foreach(filesTree($root, ".") as $path) {
            $ext = path($path, "extension");
            $basename = path($path, "basename");
            if(!in_array($ext, [ "xml", "php", "js", "css", "json" ]) && strstr($basename, ".xml.")) {
                unlink($path);
                echo "[Deleted:] \"$path\"<br>\n";
                $deleted[] = $path;
            }
        }
        if(count($deleted) > 0) {
            echo "<hr><p>".count($deleted)." files deleted.</p>\n";
        }
        else {
            echo "<p>Nothing to delete found.</p>\n";
        }
    };
              
    function contentlinkFixes($xml) {
    // Edit _category, _conections links etc.
        foreach(array_keys($xml) as $article_name) {
            $article_group = $xml[$article_name];
            if(substr($article_name, 0, 1) != "_") {
                foreach(array_keys($article_group) as $article_num) {
                    $article = $article_group[$article_num];
                    foreach(array_keys($article) as $section_name) {
                        if(substr($section_name, 0, 1) == "_" || $section_name == "path") {
                            $section = $article[$section_name][0];
                            //arrayList($section);
                            foreach(array_keys($section) as $tag) {
                                $val = $section[$tag][0];
                                if(array_pop(explode(".", $val)) == "xml") {
                                    $val = str_replace("xml", "json", $val);
                                    echo "Edit: [$article_name-$article_num-$section_name-0-$tag-0]: \"$val\"<br>\n";
                                    $xml[$article_name][$article_num][$section_name][0][$tag][0] = $val;
                                }
                            }
                        }
                    }
                }
            }
        };
        return $xml;
    };
              
    function xmlToJson($path, $backup_folder) {
    // Load XML, convert to JSON
        $xml = join(" ", array_map("trim", file($path)));
        $xml = xmlToArray($xml);
        if(is_array($xml)) {
            if(array_shift(array_keys($xml)) == "xable") { $xml = $xml['xable'][0]; };
            $xml = contentlinkFixes($xml);
            $json = arrayToJson($xml);
            if($json && json_decode($json)) {
                $dir = path($path, "dirname");
                if($dir && $dir != "") { $dir = $dir."/"; };
                $new_path = $dir.str_replace(".xml", ".json", path($path, "basename"));
                backupSave($path, $new_path, $json, $backup_folder);
                //echo "<textarea style='width:100%;height:auto'>".$json."</textarea><br>\n";
            }
            else {
                echo "#ERROR! Conversion to JSON failed: $path<br>\n";
            }
        }
        else {
            echo "#ERROR! Not valid XML: $path<br>\n";
        }
    };
              
    function backupSave($path, $new_path, $content, $backup_folder) {
    // Move original file to backup folder and save the new one
        $bak_path = $backup_folder."/".str_replace("/", "%", $path);
        if(is_string($content) && $content != "") {
            rename($path, $bak_path);
            file_put_contents($new_path, $content);
            echo "Move: $path -> $bak_path | Save content to: $new_path<br>\n";
        }
        else {
            rename($path, $bak_path);
            copy($new_path, $path);
            echo "Move: $path -> $bak_path | Copy $new_path -> $path<br>\n";
        }
    };
              
    // ====================================
    //             Main Script
    // ====================================
    
    // ====== Cleaner ======
    echo "<h1>Xable-Jable Updater &amp; Cleaner</h1><hr>\n";
    if(isset($_POST["action"]) && $_POST["action"] == "delete") {
        jableCleaner($site_root);
    }

    // ====== Fix order ======
    elseif(isset($_POST["action"]) && $_POST["action"] == "fix_order_links") {
        $backup_folder = "$site_root/tmp/xable-jable";
        foreach(filesTree($site_root."/pages", ".") as $file) {
            if(path($file, "basename") == ".order") {
                xmlToJson($file, $backup_folder);
            }
        }
    }

    // ====== Folder converter ======
    elseif(isset($_POST["action"]) && $_POST["action"] == "convert_folder") {
        //arrayList($_POST);
        $path = trim($_POST["path"]);
        if($path == "") {
            echo "ERROR! No folder path specified!<br>";
        }
        else {
            if(substr($path, (strlen($path) - 1)) == "/") { $path = substr($path, 0, (strlen($path) - 1)); };
            echo "[Folder path]: ".$path."<br>\n";
            // Variables
            $backup_folder = "$site_root/tmp/xable-jable";
            $xable_ext = [ "draft", "prev", "xml", "order", "template" ];
            // Include subfolders option
            if(isset($_POST["include_subfolders"]) && $_POST["include_subfolders"] != "") {
                $files_list = filesTree($site_root."/".$path, ".");
            }
            else {
                $files_list = listDir($site_root."/".$path, ".,?");
            }
            // Convert loop
            foreach($files_list as $file) {
                $ext = path($file, "extension");
                if(in_array($ext, $xable_ext)) {
                    //echo "> $file<br>\n";
                    $json = xmlToJson($file, $backup_folder);
                }
            }
        };
        
    }
              
    // ====== No action / simple convert ======
    else {
        echo "<form method='post'>\n";
        echo "<p>Delete all XML remains after update from 4 to 5.</p>\n";
        echo "<button name='action' value='delete' type='submit'>Submit</button>\n";
        echo "</form>\n";

        if(isset($_POST["action"]) && $_POST["action"] == "convert") {
            $xml = $_POST["xml"];
            $array = xmlToArray($xml)["xable"][0];
            $json = arrayToJson($array);
        }
        else {
            $xml = "";
            $json = "";
        }
        
        echo "<br><hr>\n";
        echo "<form method='post'>\n";
        echo "<p>Covert XML code to JSON</p>\n";
        echo "<div id='outputs'>\n";
        echo "<textarea id='xml' placeholder='XML' name='xml'>$xml</textarea>\n";
        echo "<textarea id='json' placeholder='JSON' disabled>$json</textarea>\n";
        echo "</div>\n";
        echo "<button name='action' value='convert' type='submit'>Convert</button>\n";
        echo "</form>\n";
        
        echo "<br><hr>\n";
        echo "<form method='post'>\n";
        echo "<p>Convert files in specified path:</p>\n";
        echo "<input type='text' class='text' id='path' placeholder='Folder path' name='path'>\n";
        echo "<p><input type='checkbox' id='include_subfolders' name='include_subfolders'>Include subfolders</p>\n";
        echo "<button name='action' value='convert_folder' type='submit'>Convert</button>\n";
        echo "</form>\n";
        
        /*
        echo "<br><hr>\n";
        echo "<form method='post'>\n";
        echo "<p>Convert .order files:</p>\n";
        echo "<button name='action' value='fix_order_links' type='submit'>Fix</button>\n";
        echo "</form>\n";
        */
    };

?> 
        
    </body>
</html>