var ANIMATION_TIME = 250;

$(document).ready(function() {
    
    // ==========================================
    //                 FUNCTIONS
    // ==========================================
    
    function validateLogin($input) {
        val = $input.val();
        if(val == "") { alert(LOCALIZE["empty-input-alert"]); }
        else if(val.length < 3) { alert(LOCALIZE["short-text-alert"]); }
        else if(val.indexOf(" ") >  -1) { alert(LOCALIZE["no-spaces-alert"]); }
        else { val = false; };
        // Invalid action
        if(val) {
            $input.css({ "border-color": "orange" }).focus();
            return false;
        }
        else {
            $input.attr("style", "");
            return true;
        };
    };
        
    function validatePassword($input, $repeat_input) {
        val = $input.val();
        if(val == "") { alert(LOCALIZE["empty-input-alert"]); }
        else if(val.length < 6) { alert(LOCALIZE["short-text-alert"]); }
        else if(val.indexOf(" ") >  -1) { alert(LOCALIZE["no-spaces-alert"]); }
        else { val = false; };
        // Invalid action
        if(val) {
            $input.css({ "border-color": "orange" }).focus();
            $repeat_input.prop("disabled", true);
            return false;
        }
        else {
            $input.attr("style", "");
            $repeat_input.prop("disabled", false);
            return true;
        };
    };
        
    function validateRepeatPassword($input, $pass_input) {
        pass = $pass_input.val();
        if(pass != "") {
            val = $input.val();
            if(val != pass) {
                alert(LOCALIZE["different-passwords"]);
                $input.css({ "border-color": "orange" }).focus();
                return false;
            }
            else {
                $input.attr("style", "").focus();
                return true;
            }
        }
        else {
            $input.attr("style", "");
        }
    };
    
    function enableUser() {
        $li = $("#options .create_admin");
        var disabled = false;
        if($li.find("input.create_admin").prop("checked") == false) { disabled = true; };
        while(($li = $li.next("li")) && $li.length) {
            $input = $li.find("input");
            $input.prop("disabled", disabled);
            //if(disabled) { $input.val(""); }; // Clear inputs
        };
        allFilled();
    }
    
    function allFilled() {
        var filled = true;
        if($("#options .create_admin input.create_admin").prop("checked") == true) {
            $("input.text").each(function() {
                if($(this).val() == "") { filled = false; };
            });
            if($("input.password").val() != $("input.repeat_password").val()) { filled = false; };
        };
        if(filled) {
            $("#options .buttons .submit").prop("disabled", false).removeClass("off");
        }
        else {
            $("#options .buttons .submit").prop("disabled", true).addClass("off");
        }
    };
    
    // ==========================================
    //                  Summary
    // ==========================================
    
    if($("#post_output input.installer_stage").val() == "summary") {
        $("#summary").show();
        if($("#post_output input.summary_mode").val() == "done") {
            $("#summary li.failed").hide();
            $("#summary button.submit").removeClass("off").prop("disabled", false);
        }
        else {
            $("#summary li.done").hide();
        }
    }
    // ==========================================
    //                  Options
    // ==========================================
    else {
        $("#options").show();
        
        if($("#post_output input.installer_mode").val() == "complete") {
            // Instalation mode
            $("#options .installer_mode input.complete").prop("checked", true);
            $("#options .installer_mode input.update").prop("disabled", true).closest("label").css({ "color": "#aaa" });
            // Create user
            $("#options .create_admin input.create_admin").prop("checked", true).prop("disabled", true).closest("label").css({ "color": "#aaa" });
        }
        else {
            $("#options .installer_mode input.update").prop("checked", true);
        };
        
        setTimeout(function() {
            $("input.text").val(""); // Kill autofill

            $("input.login").change(function() { validateLogin($(this)); $(".create_admin input").prop("checked", true); });
            $("input.password").change(function() { validatePassword($(this), $("input.repeat_password")); $("input.repeat_password").val(""); });
            $("input.repeat_password").change(function() { validateRepeatPassword($(this), $("input.password")); });
            $("#options .create_admin input.create_admin").change(function() { enableUser(); });

            $("input.password").keyup(function() { $("input.repeat_password").prop("disabled", false); });
            
            $("input.repeat_password").keyup(function() { allFilled(); });
            
            $("#options .buttons .submit").click(function() {
                if(
                    $("#options .create_admin input.create_admin").prop("checked") == false ||
                    (
                        validateLogin($("input.login")) &&
                        validatePassword($("input.password"), $("input.repeat_password")) &&
                        validateRepeatPassword($("input.repeat_password"), $("input.password"))
                    )
                ) {
                    $form = $(this).closest("form");
                    $("form input").prop("disabled", false);
                    $("#loader").fadeIn(ANIMATION_TIME, function() {
                        $form.submit();
                    });
                };
                return false;
            });
            
            enableUser();
        }, 500);
    }
    
    function updateOptions() {
        mode = $("input.installer_mode:checked").attr("class").split(" ").pop();
        if(mode == "update") {
            $("#options #user").slideUp(ANIMATION_TIME);
            $("#options #update_helper").slideDown(ANIMATION_TIME);
            $(".installer_mode input.complete").closest("label").attr("class", "off");
            $(".installer_mode input.update").closest("label").attr("class", "on");
            
            $("#options .create_admin input.create_admin").prop("checked", false);
        }
        else {
            $("#options #user").slideDown(ANIMATION_TIME);
            $("#options #update_helper").slideUp(ANIMATION_TIME);
            $(".installer_mode input.complete").closest("label").attr("class", "on");
            $(".installer_mode input.update").closest("label").attr("class", "off");
            
            $("#options .create_admin input.create_admin").prop("checked", true);
        };
        enableUser();
    };
    
    if(!$("#post_output input.summary_mode").length || $("#post_output input.summary_mode").val() != "done") {
        updateOptions();
        $(".installer_mode").change(function() { updateOptions(); })
    };
    
    // ==========================================
    //               Updater tool
    // ==========================================
    
    $(".updater a").click(function() {
        href = $(this).attr("href");
        win_wid = $(window).width();
        if(win_wid > 1200) { win_wid = win_wid * 0.5; }
        else if(win_wid > 800) { win_wid = win_wid * 0.7; }
        else { win_wid = "100%"; };
        win_hei = $(window).height()
        if(win_hei > 600) { win_hei = win_hei * 0.85; }
        else { win_hei = "100%"; };        
        //window.open(href);
        window.open(href, "updater", "width=" + win_wid + ",height=" + win_hei);
        return false;
    })
    
    // ==========================================
    // ==========================================
    // ==========================================
    //                  Launch
    // ==========================================
    // ==========================================
    // ==========================================
    
    setTimeout(function() {
        $("form article").show();
        $("#loader").fadeOut(ANIMATION_TIME);
    }, 500);

});